<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Prototypes, Classes, Objects</title>
</head>

<body>
    <script>
        // Exercise 2

        class StateDocument {
            constructor(firstName, lastName, personalCode, issuer, documentNumber, dateOfExpiry) {
                this.firstName = firstName;
                this.lastName = lastName;
                this.personalCode = personalCode;
                this.issuer = issuer;
                this.documentNumber = documentNumber;
                this.dateOfExpiry = dateOfExpiry;
            }

            get expired() {
                return new Date() >= this.dateOfExpiry;
            }

            getDetails() {
                return `
                    --- GENERAL DATA ---
                    NAME: ${this.firstName} ${this.lastName}
                    PERSONAL CODE: ${this.personalCode}
                    ISSUER: ${this.issuer}
                    DOCUMENT NUMBER: ${this.documentNumber}
                    EXPIRES: ${this.dateOfExpiry}
                    IS VALID: ${!this.expired}
                `;
            }
        }

        class IDCard extends StateDocument {
            constructor(firstName, lastName, personalCode, issuer, documentNumber, dateOfExpiry, citizenship) {
                super(firstName, lastName, personalCode, issuer, documentNumber, dateOfExpiry);
                this.citizenship = citizenship;
            }

            getDetails() {
                return super.getDetails() + `
                    --- ID DATA ---
                    CITIZENSHIP: ${this.citizenship}
                `;
            }
        }

        class DriversLicense extends StateDocument {
            constructor(firstName, lastName, personalCode, issuer, documentNumber, dateOfExpiry, categories) {
                super(firstName, lastName, personalCode, issuer, documentNumber, dateOfExpiry);
                this.categories = categories;
            }

            getDetails() {
                return super.getDetails() + `
                    --- DRIVING DATA ---
                    CATEGORIES: ${this.categories.join(', ')}
                `;
            }
        }

        let generalDocument = new StateDocument('Mai', 'Mallikas', '48301022456', 'SÜVARIIK', 'ET999999', new Date('2021-05-06'));
        console.log('General Document', generalDocument);
        console.log(generalDocument.getDetails());
        console.log('---');

        let idDocument = new IDCard('Mati', 'Metsis', '37604245678', 'POLITSEI', 'ABC123456', new Date('2019-05-25'), 'EST');
        console.log('ID Card', idDocument);
        console.log(idDocument.getDetails());
        console.log('---');

        let driversLicense = new DriversLicense('Kersti', 'Tamm', '49009085678', 'MAANTEEAMET', 'ET123456', new Date('2023-09-01'), ['A', 'B', 'C']);
        console.log('Drivers License', driversLicense);
        console.log(driversLicense.getDetails());
        console.log('---');

        // Prototype-based approach

        function StateDocumentP(firstName, lastName, personalCode, issuer, documentNumber, dateOfExpiry) {
            this.firstName = firstName;
            this.lastName = lastName;
            this.personalCode = personalCode;
            this.issuer = issuer;
            this.documentNumber = documentNumber;
            this.dateOfExpiry = dateOfExpiry;
        }

        StateDocumentP.prototype = {
            get expired() {
                return new Date() >= this.dateOfExpiry;
            }
        }

        StateDocumentP.prototype.getDetails = function () {
            return `
                    --- GENERAL DATA ---
                    NAME: ${this.firstName} ${this.lastName}
                    PERSONAL CODE: ${this.personalCode}
                    ISSUER: ${this.issuer}
                    DOCUMENT NUMBER: ${this.documentNumber}
                    EXPIRES: ${this.dateOfExpiry}
                    IS VALID: ${!this.expired}
                `;
        }

        function IDCardP(firstName, lastName, personalCode, issuer, documentNumber, dateOfExpiry, citizenship) {
            StateDocumentP.call(this, firstName, lastName, personalCode, issuer, documentNumber, dateOfExpiry);
            this.citizenship = citizenship;
        }

        IDCardP.prototype.getDetails = function () {
            return StateDocumentP.prototype.getDetails.call(this) + `
                    --- ID DATA ---
                    CITIZENSHIP: ${this.citizenship}
                `;
        }

        Object.setPrototypeOf(IDCardP.prototype, StateDocumentP.prototype);

        function DriversLicenseP(firstName, lastName, personalCode, issuer, documentNumber, dateOfExpiry, categories) {
            StateDocumentP.call(this, firstName, lastName, personalCode, issuer, documentNumber, dateOfExpiry);
            this.categories = categories;
        }

        DriversLicenseP.prototype.getDetails = function () {
            return StateDocumentP.prototype.getDetails.call(this) + `
                    --- ID DATA ---
                    CATEGORIES: ${this.categories.join(', ')}
                `;
        }

        Object.setPrototypeOf(DriversLicenseP.prototype, StateDocumentP.prototype);

        let generalDocumentP = new StateDocumentP('MaiP', 'MallikasP', '48301022456', 'SÜVARIIK', 'ET999990', new Date('2021-05-06'));
        console.log('General Document (prototype approach)', generalDocumentP);
        console.log(generalDocumentP.getDetails());
        console.log('---');

        let idDocumentP = new IDCardP('MatiP', 'MetsisP', '37604245678', 'POLITSEI', 'ABC123450', new Date('2019-05-25'), 'EST');
        console.log('ID Card (prototype approach)', idDocumentP);
        console.log(idDocumentP.getDetails());
        console.log('---');

        let driversLicenseP = new DriversLicenseP('KerstiP', 'TammP', '49009085678', 'MAANTEEAMET', 'ET123450', new Date('2023-09-01'), ['A', 'B', 'C']);
        console.log('Drivers License (prototype approach)', driversLicenseP);
        console.log(driversLicenseP.getDetails());
        console.log('---');

    </script>
</body>

</html>